/**
 *	@file unitst_true_test.c
 *	@brief	unitst̂̐eXg.
 *	@note
 */

#include "../unitst.h"

#ifdef _WIN32
 #include <tchar.h>
 #ifdef __BORLANDC__
  #ifdef UNICODE
   #define TCHAR	wchar_t
  #else
   #define TCHAR	char
  #endif
 #endif
 #define int64_t	__int64
 #define uint64_t	unsigned __int64
#else
 #include <stdint.h>
#endif



// p^[݂̂ňʂ}Ngp.
UNITST_TEST( UniTst_true )
{
	int 			i0 = 0;
	int 			i1 = 1;
	static unsigned ui = 100;
	int* pi0   = &i0;
	int* nullp = 0;
	int64_t  ll0 = 0;
	int64_t  ll1 = 10000;
	uint64_t ull = 10000;
	float		f0	= 0.f;
	float	 	f1	= 10.f;
	double	 	d0	= 0.0;
	double		d1	= 1.0;
	double 		ary[10] = {0};
	double* 	pa		= &ary[9];
	long double	ld0	= 0.0;
	long double	ld1	= 1.0;
	const char 	str0[] = "string";
  #ifndef ANSIC89
	const wchar_t wstr0[] = L"string";
  #endif

	if (i0 == (int)(ui)) {	//̒ɂ͂Ȃ...
		UNITST_ADD_FAILUSE();
		UNITST_FAIL();
	}
	UNITST_ASSERT(i0 == i1-1);
	UNITST_ASSERT_MSG(1, "assert_msg\n");
	UNITST_ASSERT_MSGF(i0+1 == i1, ("check_msg\n"));

	UNITST_ASSERT_PTR(pi0);
	UNITST_ASSERT_PTR0(pi0);
	UNITST_ASSERT_PTR0(nullp);

	UNITST_CHECK(i0 == i1-1);
	UNITST_CHECK_MSG(1, "assert_msg\n");
	UNITST_CHECK_MSGF(i0+1 == i1, ("check_msg\n"));
	UNITST_CHECK_PTR(pi0);
	UNITST_CHECK_PTR0(pi0);
	UNITST_CHECK_PTR0(nullp);

	UNITST_LIMIT(i0, 0, 10000);

	UNITST_LIM_BOOL(i0);
	UNITST_LIM_BOOL(i1);
	UNITST_LIM_I(i0, 0, +10000);
	UNITST_LIM_I(i1, -10, +10000);
	UNITST_LIM_I(ui,  10, +10000);


	UNITST_LIMIT(ll0, 0, 10000);
	UNITST_LIM_LL(ll0, 0, 10000);
	UNITST_LIM_LL(ll1, -10, 10000);
	UNITST_LIM_LL(ull, 10, 100000);

	UNITST_LIMIT(f0, 0.f, +10000.f);
	UNITST_LIM_F(f0, 0.f, +10000.f);
	UNITST_LIM_F(f1, -10.f, +10000.f);

	UNITST_LIMIT(d0, -0.0, +10000.0);
	UNITST_LIM_D(d0, -0.0, +10000.0);
	UNITST_LIM_D(d1, -10.1, +10000.0);

	UNITST_LIMIT(pa, ary, ary+9);
	UNITST_LIM_PTR(pa, ary, ary+9);

	UNITST_LIMIT(ld0, -0.0, +10000.0);
	UNITST_LIM_LD(ld0, -0.0, +10000.0);
	UNITST_LIM_LD(ld1, -10.1, +10000.0);

	UNITST_EQ(i0, f0);
	UNITST_EQ(i1, 1);
	UNITST_EQ(ll0, 0);
	UNITST_EQ(f0, 0);
	UNITST_EQ(d0, 0);
	UNITST_EQ(ld0, 0);

	UNITST_EQ_I(i1, 1);
	UNITST_EQ_LL(ll0, 0);
	UNITST_EQ_F(f0, 0);
	UNITST_EQ_D(d0, 0);
	UNITST_EQ_LD(ld0, 0);
	UNITST_EQ_STR(str0, "string");
	UNITST_EQ_STRI(str0, "STRING");
	UNITST_EQ_STRN(str0, "str", 3);
	UNITST_EQ_STRNI(str0, "sTr", 3);
	UNITST_EQ_MEM(str0, "string", 7);

  #ifndef ANSIC89
	UNITST_EQ_WSTR(wstr0, L"string");
	UNITST_EQ_WSTRI(wstr0, L"STRING");
	UNITST_EQ_WSTRN(wstr0, L"str", 3);
	UNITST_EQ_WSTRNI(wstr0, L"sTr", 3);

   #ifdef _WIN32
	{
		const TCHAR tstr0[] = _T("string");
		UNITST_EQ_TSTR(tstr0, _T("string"));
		UNITST_EQ_TSTRI(tstr0, _T("STRING"));
		UNITST_EQ_TSTRN(tstr0, _T("str"), 3);
		UNITST_EQ_TSTRNI(tstr0, _T("sTr"), 3);
	}
   #endif
  #endif

	UNITST_EQ_DELTA_F(f0, 0, 0);
	UNITST_EQ_DELTA_D(d0, 0, 0);

	UNITST_NE(i0, i1);
	UNITST_NE(i1, 0);
	UNITST_NE(ll0, 1);
	UNITST_NE(f0, 1);
	UNITST_NE(d0, 1);
	UNITST_NE(ld0, 1);

	UNITST_NE_I(i1, 0);
	UNITST_NE_LL(ll0, 1);
	UNITST_NE_F(f0, 1);
	UNITST_NE_D(d0, 1);
	UNITST_NE_LD(ld0, 1);
	UNITST_NE_MEM(str0, "string1", 7);

	UNITST_LT(i0, i1);
	UNITST_LT(i0, i1);
	UNITST_LT(ll0, 1);
	UNITST_LT(f0, 1);
	UNITST_LT(d0, 1);
	UNITST_LT(ld0, 1);

	UNITST_LT_I(i0, i1);
	UNITST_LT_LL(ll0, 1);
	UNITST_LT_F(f0, 1);
	UNITST_LT_D(d0, 1);
	UNITST_LT_LD(ld0, 1);

	UNITST_LE(i0, 0);

	UNITST_LE(i0, 0);
	UNITST_LE(i0, i1);
	UNITST_LE(ll0, 0);
	UNITST_LE(ll0, 1);
	UNITST_LE(f0, 0);
	UNITST_LE(f0, 1);
	UNITST_LE(d0, 0);
	UNITST_LE(d0, 1);
	UNITST_LE(ld0, 0);
	UNITST_LE(ld0, 1);

	UNITST_LE_I(i0, 0);
	UNITST_LE_I(i0, i1);
	UNITST_LE_LL(ll0, 0);
	UNITST_LE_LL(ll0, 1);
	UNITST_LE_F(f0, 0);
	UNITST_LE_F(f0, 1);
	UNITST_LE_D(d0, 0);
	UNITST_LE_D(d0, 1);
	UNITST_LE_LD(ld0, 0);
	UNITST_LE_LD(ld0, 1);

	UNITST_GT(i1, 0);
	UNITST_GT(i1, 0);
	UNITST_GT(ll1, 0);
	UNITST_GT(f1, 0);
	UNITST_GT(d1, 0);
	UNITST_GT(ld1, 0);

	UNITST_GT_I(i1, 0);
	UNITST_GT_LL(ll1, 0);
	UNITST_GT_F(f1, 0);
	UNITST_GT_D(d1, 0);
	UNITST_GT_LD(ld1, 0);

	i1	= 1;
	ll1 = 1;
	f1	= 1;
	d1	= 1;
	UNITST_GE(i1, 0);
	UNITST_GE(i1, 1);
	UNITST_GE(i1, 0);
	UNITST_GE(i1, 1);
	UNITST_GE(ll1, 0);
	UNITST_GE(ll1, 1);
	UNITST_GE(f1, 0);
	UNITST_GE(f1, 1);
	UNITST_GE(d1, 0);
	UNITST_GE(d1, 1);
	UNITST_GE(ld1, 0);
	UNITST_GE(ld1, 1);

	UNITST_GE_I(i1, 0);
	UNITST_GE_I(i1, 1);
	UNITST_GE_LL(ll1, 0);
	UNITST_GE_LL(ll1, 1);
	UNITST_GE_F(f1, 0);
	UNITST_GE_F(f1, 1);
	UNITST_GE_D(d1, 0);
	UNITST_GE_D(d1, 1);
	UNITST_GE_LD(ld1, 0);
	UNITST_GE_LD(ld1, 1);

	#if __STDC_VERSION__ >= 199901L || (_MSC_VER >= 1400) || (__GNUC__ >= 3) || (__BORLANDC__ >= 0x580) || (__WATCOMC__ >= 1260)	//|| (__SC__ >= 850)
		UNITST_ASSERT_MSG(1, "assert_msg %d\n", i1);
		UNITST_CHECK_MSG(1, "assert_msg %d\n", i1);
	#endif
}

