/**
 *	@file unitst_test.cpp
 *	@brief	unitst̂̃eXg.
 *	@note
 *		_I,_LL,_F,_D,_LD t̋o[W̃}Nw肪c܂
 */

#define USE_UNITST		100
#define USE_UNITST_STRSTREAM
#include "../unitst.h"

#include <algorithm>
#include <string>

#ifdef _WIN32
 #include <tchar.h>
 #ifdef __BORLANDC__
  #ifdef UNICODE
   #define TCHAR	wchar_t
  #else
   #define TCHAR	char
  #endif
 #endif
 #define int64_t	__int64
 #define uint64_t	unsigned __int64
#else
 #include <stdint.h>
#endif

//#define USE_WTL
#ifdef USE_WTL
#include <atlbase.h>
#include <c:/lib/wtl80/include/atlapp.h>
#include <c:/lib/wtl80/include/atlmisc.h>
#endif


#define AST_CHK(x)		do { try { x; printf("'%s' failed.\n", #x); } catch (UNITST_Fail_Exception) {} catch(...) { printf("'%s' failed!!\n", #x); } } while (0)

static void func0(void) {}


// p^[݂̂ňʂ}Ngp.
UNITST_TEST( UniTst_true )
{
	int 			i0 = 0;
	int 			i1 = 1;
	static unsigned ui = 100;

	if (i0 == int(ui)) {	//̒ɂ͂Ȃ...
		UNITST_ADD_FAILUSE();
		UNITST_FAIL();
	}
	UNITST_ASSERT(i0 == i1-1);
	UNITST_ASSERT_MSG(1, "assert_msg\n");
	UNITST_ASSERT_MSGF(i0+1 == i1, ("check_msg\n"));
	int* pi0   = &i0;
	int* nullp = 0;
	UNITST_ASSERT_PTR(pi0);
	UNITST_ASSERT_PTR0(pi0);
	UNITST_ASSERT_PTR0(nullp);
	struct St1 {};
	UNITST_ASSERT_THROW(throw St1(), St1);
	UNITST_ASSERT_ANY_THROW(throw St1());
	UNITST_ASSERT_NO_THROW( func0() );

	UNITST_CHECK(i0 == i1-1);
	UNITST_CHECK_MSG(1, "assert_msg\n");
	UNITST_CHECK_MSGF(i0+1 == i1, ("check_msg\n"));
	UNITST_CHECK_PTR(pi0);
	UNITST_CHECK_PTR0(pi0);
	UNITST_CHECK_PTR0(nullp);
	UNITST_CHECK_THROW(throw St1(), St1);
	UNITST_CHECK_ANY_THROW(throw St1());
	UNITST_CHECK_NO_THROW( func0() );

	UNITST_LIMIT(i0, 0, 10000);

	UNITST_LIM_BOOL(i0);
	UNITST_LIM_BOOL(i1);
	UNITST_LIM_I(i0, 0, +10000);
	UNITST_LIM_I(i1, -10, +10000);
	UNITST_LIM_I(ui,  10, +10000);

	int64_t  ll0 = 0;
	int64_t  ll1 = 10000;
	uint64_t ull = 10000;

	UNITST_LIMIT(ll0, 0, 10000);
	UNITST_LIM_LL(ll0, 0, 10000);
	UNITST_LIM_LL(ll1, -10, 10000);
	UNITST_LIM_LL(ull, 10, 100000);

	float		f0	= 0.f;
	float	 	f1	= 10.f;
	UNITST_LIMIT(f0, 0.f, +10000.f);
	UNITST_LIM_F(f0, 0.f, +10000.f);
	UNITST_LIM_F(f1, -10.f, +10000.f);

	double	 	d0	= 0.0;
	double		d1	= 1.0;
	UNITST_LIMIT(d0, -0.0, +10000.0);
	UNITST_LIM_D(d0, -0.0, +10000.0);
	UNITST_LIM_D(d1, -10.1, +10000.0);

	double 		ary[10] = {0};
	double* 	pa		= &ary[9];
	UNITST_LIMIT(pa, ary, ary+9);
	UNITST_LIM_PTR(pa, ary, ary+9);

	long double	 	ld0	= 0.0;
	long double		ld1	= 1.0;
	UNITST_LIMIT(ld0, -0.0, +10000.0);
	UNITST_LIM_LD(ld0, -0.0, +10000.0);
	UNITST_LIM_LD(ld1, -10.1, +10000.0);

	const char str0[] = "string";

	UNITST_EQ(i0, f0);
	UNITST_EQ(i1, 1);
	UNITST_EQ(ll0, 0);
	UNITST_EQ(f0, 0);
	UNITST_EQ(d0, 0);
	UNITST_EQ(ld0, 0);

	UNITST_EQ_I(i1, 1);
	UNITST_EQ_LL(ll0, 0);
	UNITST_EQ_F(f0, 0);
	UNITST_EQ_D(d0, 0);
	UNITST_EQ_LD(ld0, 0);
	UNITST_EQ_STR(str0, "string");
	UNITST_EQ_STRI(str0, "STRING");
	UNITST_EQ_STRN(str0, "str", 3);
	UNITST_EQ_STRNI(str0, "sTr", 3);
	UNITST_EQ_MEM(str0, "string", 7);

	const wchar_t wstr0[] = L"string";
	UNITST_EQ_WSTR(wstr0, L"string");
	UNITST_EQ_WSTRI(wstr0, L"STRING");
	UNITST_EQ_WSTRN(wstr0, L"str", 3);
	UNITST_EQ_WSTRNI(wstr0, L"sTr", 3);

  #ifdef _WIN32
	const TCHAR tstr0[] = _T("string");
	UNITST_EQ_TSTR(tstr0, _T("string"));
	UNITST_EQ_TSTRI(tstr0, _T("STRING"));
	UNITST_EQ_TSTRN(tstr0, _T("str"), 3);
	UNITST_EQ_TSTRNI(tstr0, _T("sTr"), 3);
  #endif

	UNITST_EQ_CLCTN(str0, str0+6, "string");
	UNITST_EQ_DELTA_F(f0, 0, 0);
	UNITST_EQ_DELTA_D(d0, 0, 0);

	UNITST_NE(i0, i1);
	UNITST_NE(i1, 0);
	UNITST_NE(ll0, 1);
	UNITST_NE(f0, 1);
	UNITST_NE(d0, 1);
	UNITST_NE(ld0, 1);

	UNITST_NE_I(i1, 0);
	UNITST_NE_LL(ll0, 1);
	UNITST_NE_F(f0, 1);
	UNITST_NE_D(d0, 1);
	UNITST_NE_LD(ld0, 1);
  #if 0
	UNITST_NE_STR(str0, "strinG");
	UNITST_NE_STRI(str0, "rope");
	UNITST_NE_STRN(str0, "sTring", 3);
	UNITST_NE_STRNI(str0, "roPe", 3);
  #endif
	UNITST_NE_MEM(str0, "string1", 7);

	UNITST_LT(i0, i1);
	UNITST_LT(i0, i1);
	UNITST_LT(ll0, 1);
	UNITST_LT(f0, 1);
	UNITST_LT(d0, 1);
	UNITST_LT(ld0, 1);

	UNITST_LT_I(i0, i1);
	UNITST_LT_LL(ll0, 1);
	UNITST_LT_F(f0, 1);
	UNITST_LT_D(d0, 1);
	UNITST_LT_LD(ld0, 1);

	UNITST_LE(i0, 0);

	UNITST_LE(i0, 0);
	UNITST_LE(i0, i1);
	UNITST_LE(ll0, 0);
	UNITST_LE(ll0, 1);
	UNITST_LE(f0, 0);
	UNITST_LE(f0, 1);
	UNITST_LE(d0, 0);
	UNITST_LE(d0, 1);
	UNITST_LE(ld0, 0);
	UNITST_LE(ld0, 1);

	UNITST_LE_I(i0, 0);
	UNITST_LE_I(i0, i1);
	UNITST_LE_LL(ll0, 0);
	UNITST_LE_LL(ll0, 1);
	UNITST_LE_F(f0, 0);
	UNITST_LE_F(f0, 1);
	UNITST_LE_D(d0, 0);
	UNITST_LE_D(d0, 1);
	UNITST_LE_LD(ld0, 0);
	UNITST_LE_LD(ld0, 1);

	UNITST_GT(i1, 0);
	UNITST_GT(i1, 0);
	UNITST_GT(ll1, 0);
	UNITST_GT(f1, 0);
	UNITST_GT(d1, 0);
	UNITST_GT(ld1, 0);

	UNITST_GT_I(i1, 0);
	UNITST_GT_LL(ll1, 0);
	UNITST_GT_F(f1, 0);
	UNITST_GT_D(d1, 0);
	UNITST_GT_LD(ld1, 0);

	i1	= 1;
	ll1 = 1;
	f1	= 1;
	d1	= 1;
	UNITST_GE(i1, 0);
	UNITST_GE(i1, 1);
	UNITST_GE(i1, 0);
	UNITST_GE(i1, 1);
	UNITST_GE(ll1, 0);
	UNITST_GE(ll1, 1);
	UNITST_GE(f1, 0);
	UNITST_GE(f1, 1);
	UNITST_GE(d1, 0);
	UNITST_GE(d1, 1);
	UNITST_GE(ld1, 0);
	UNITST_GE(ld1, 1);

	UNITST_GE_I(i1, 0);
	UNITST_GE_I(i1, 1);
	UNITST_GE_LL(ll1, 0);
	UNITST_GE_LL(ll1, 1);
	UNITST_GE_F(f1, 0);
	UNITST_GE_F(f1, 1);
	UNITST_GE_D(d1, 0);
	UNITST_GE_D(d1, 1);
	UNITST_GE_LD(ld1, 0);
	UNITST_GE_LD(ld1, 1);

	#if __STDC_VERSION__ >= 199901L || (_MSC_VER >= 1400) || (__GNUC__ >= 3) || (__BORLANDC__ >= 0x580) || (__WATCOMC__ >= 1260)	//|| (__SC__ >= 850)
		UNITST_ASSERT_MSG(1, "assert_msg %d\n", i1);
		UNITST_CHECK_MSG(1, "assert_msg %d\n", i1);
	#endif

  #if !(defined __WATCOMC__)
	std::string ssB("b"), ssA("a"), ssZ("z");
	UNITST_EQ(ssA, std::string("a"));
	UNITST_NE(ssA, ssB);
	UNITST_LT(ssA, ssB);
	UNITST_LE(ssA, ssB);
	UNITST_GT(ssZ, ssB);
	UNITST_GE(ssZ, ssB);
	UNITST_LIMIT(ssB, ssA, ssZ);

	UNITST_EQ_STRING(ssA, std::string("a"));
	UNITST_EQ_STRING(ssA, "a");
	UNITST_EQ_STRING("b", ssB);
  #endif

  #ifdef USE_WTL
	CString csB("b"), csA("a"), csZ("z");
	UNITST_EQ_CSTRING(csA, CString("a"));
	UNITST_EQ_CSTRING(csA, "a");
	UNITST_EQ_CSTRING("b", csB);
  #endif
}



// sp^[݂̂ňʂ}Ngp.
//UNITST_TEST( UniTst_false )
void UniTst_false()
{
	int 			i0 = 0;
	int 			i1 = 1;
	static unsigned ui = 100;

	UNITST_ADD_FAILUSE();
	AST_CHK( UNITST_FAIL() );

	AST_CHK( UNITST_ASSERT(i0 != i1-1) );
	AST_CHK( UNITST_ASSERT_MSG(0, "assert_msg\n") );
	AST_CHK( UNITST_ASSERT_MSGF(i0+1 != i1, ("assert_msgf %d,%d\n",1,2)) );
	int* pi0   = (int*)1;
	int* nullp = 0;
	AST_CHK( UNITST_ASSERT_PTR(nullp) );
	AST_CHK( UNITST_ASSERT_PTR0(pi0) );
	struct St3 {};
	struct St2 {};
	AST_CHK( UNITST_ASSERT_THROW(throw St2(), St3) );
	AST_CHK( UNITST_ASSERT_ANY_THROW(func0()) );		//  dmc(850,851)ł͂Ȃ AST_CHKfailedɂȂ...
	AST_CHK( UNITST_ASSERT_NO_THROW( throw St3() ) );

	UNITST_CHECK(i0 != i1-1);
	UNITST_CHECK_MSG(0, "check_msg\n");
	UNITST_CHECK_MSGF(i0+1 != i1, ("check_msgf %d,%d\n",1,2));
	UNITST_CHECK_PTR(nullp);
	UNITST_CHECK_PTR0(pi0);
	UNITST_CHECK_THROW(throw St3(), St2);
	UNITST_CHECK_ANY_THROW(func0());
	UNITST_CHECK_NO_THROW( throw St3() );

	UNITST_LIMIT(i0, 1, +10000);

	UNITST_LIM_BOOL(ui);
	UNITST_LIM_I(i0, 1, +10000);
	UNITST_LIM_I(i1, -10, 0);
	UNITST_LIM_I(ui,  1, 99);

	int64_t  ll0 = 0;
	int64_t  ll1 = 10000;
	uint64_t ull = 10000;

	UNITST_LIM_LL(ll0, 1, +10000);
	UNITST_LIM_LL(ll1, -10, 0);
	UNITST_LIM_LL(ull, 10, +100);

	float		f0	= 0.f;
	float	 	f1	= 10.f;
	UNITST_LIM_F(f0, 0.1f, +10000.f);
	UNITST_LIM_F(f1, -10.f, 9.999f);

	double	 	d0	= 0.0;
	double		d1	= 10.0;
	UNITST_LIM_D(d0, 0.001, +10000.0);
	UNITST_LIM_D(d1, -10.1, +9.9999999999);

	long double	 	ld0	= 0.0;
	long double		ld1	= 10.0;
	UNITST_LIM_LD(ld0, 0.001, +10000.0);
	UNITST_LIM_LD(ld1, -10.1, +9.9999999999);

	double 		ary[10] = {0};
	double* 	pa		= &ary[10];
	UNITST_LIM_PTR(pa, ary, ary+9);

	const char str0[] = "string";

	UNITST_EQ(i0, f1);
	UNITST_EQ(i1, 0);
	UNITST_EQ(ll0, 1);
	UNITST_EQ(f0, 1);
	UNITST_EQ(d0, 1);
	UNITST_EQ(ld0, 1);

	UNITST_EQ_I(i1, 0);
	UNITST_EQ_LL(ll0, 1);
	UNITST_EQ_F(f0, 1);
	UNITST_EQ_D(d0, 1);
	UNITST_EQ_LD(ld0, 1);
	UNITST_EQ_STR(str0, "STRING");
	UNITST_EQ_STRI(str0, "STRING1");
	UNITST_EQ_STRN(str0, "sTr", 3);
	UNITST_EQ_STRNI(str0, "St3", 3);
	UNITST_EQ_MEM(str0, "strIng", 7);

	const wchar_t wstr0[] = L"string";
	UNITST_EQ_WSTR(wstr0, L"STRING");
	UNITST_EQ_WSTRI(wstr0, L"STRING1");
	UNITST_EQ_WSTRN(wstr0, L"sTr", 3);
	UNITST_EQ_WSTRNI(wstr0, L"St3", 3);

  #ifdef _WIN32
	const TCHAR tstr0[] = _T("string");
	UNITST_EQ_TSTR(tstr0, _T("STRING"));
	UNITST_EQ_TSTRI(tstr0, _T("STRING1"));
	UNITST_EQ_TSTRN(tstr0, _T("sTr"), 3);
	UNITST_EQ_TSTRNI(tstr0, _T("St3"), 3);
  #endif

	UNITST_EQ_CLCTN(str0, str0+6, "strinG");
	UNITST_EQ_DELTA_F(f0, 1, 0);
	UNITST_EQ_DELTA_D(d0, 1, 0);

	UNITST_NE(i0, f0);
	UNITST_NE_I(i1, 1);
	UNITST_NE_LL(ll0, 0);
	UNITST_NE_F(f0, 0);
	UNITST_NE_D(d0, 0);
	UNITST_NE_LD(ld0, 0);
  #if 0
	UNITST_NE_STR(str0, "string");
	UNITST_NE_STRI(str0, "strinG");
	UNITST_NE_STRN(str0, "str1", 3);
	UNITST_NE_STRNI(str0, "sTr1", 3);
  #endif
	UNITST_NE_MEM(str0, "string", 7);

	UNITST_LT(i0, 0);
	UNITST_LT_I(i0, 0);
	UNITST_LT_LL(ll0, 0);
	UNITST_LT_F(f0, 0);
	UNITST_LT_D(d0, 0);
	UNITST_LT_LD(ld0, 0);

	UNITST_LE(i0, -1);
	UNITST_LE_I(i0, -1);
	UNITST_LE_LL(ll0, -1);
	UNITST_LE_F(f1, 0);
	UNITST_LE_D(d1, 0);
	UNITST_LE_LD(ld1, 0);

	UNITST_GT(i0, 0);
	UNITST_GT_I(i0, 0);
	UNITST_GT_LL(ll0, 0);
	UNITST_GT_F(f0, 0);
	UNITST_GT_D(d0, 0);
	UNITST_GT_LD(ld0, 0);

	UNITST_GE(i0, 10);
	UNITST_GE_I(i0, 10);
	UNITST_GE_LL(ll0, 10);
	UNITST_GE_F(f0, 10);
	UNITST_GE_D(d0, 10);
	UNITST_GE_LD(ld0, 10);

	#if __STDC_VERSION__ >= 199901L || (_MSC_VER >= 1400) || (__GNUC__ >= 3) || (__BORLANDC__ >= 0x580) || (__WATCOMC__ >= 1260)	//|| (__SC__ >= 850)
		AST_CHK( UNITST_ASSERT_MSG(0, "assert_msg ex %d,%d,%d\n", 1,2,3) );
		UNITST_CHECK_MSG(0, "check_msg ex %d,%d,%d\n", 1,2,3);
	#endif

  #if !(defined __WATCOMC__)
	std::string ssB("b"), ssA("a"), ssZ("z");
	UNITST_EQ(ssA, std::string("A"));
	UNITST_NE(ssA, "a");
	UNITST_LT(ssZ, ssB);
	UNITST_LE(ssZ, ssB);
	UNITST_GT(ssA, ssB);
	UNITST_GE(ssA, ssB);
	UNITST_LIMIT(ssA, ssB, ssZ);

	UNITST_EQ_STRING(ssA, std::string("A"));
	UNITST_EQ_STRING(ssA, "A");
	UNITST_EQ_STRING("z", ssB);
  #endif

  #ifdef USE_WTL
	CString csB("b"), csA("a"), csZ("z");
	UNITST_EQ_CSTRING(csA, CString("A"));
	UNITST_EQ_CSTRING(csA, "A");
	UNITST_EQ_CSTRING("z", csB);
  #endif
}

UNITST_ADD_FUNC( UniTst_false );



void compiler_version()
{
  #if defined _MSC_VER
	UNITST_PRINTF(("_MSC_VER = %d\n", _MSC_VER));
  #elif defined __GNUC__
	UNITST_PRINTF(("__GNUC__ = %d\n", __GNUC__));
	UNITST_PRINTF(("__GNUC_MINOR__ = %d\n", __GNUC_MINOR__));
  #elif defined __DMC__
	UNITST_PRINTF(("__SC__ = %#x\n", __SC__));
	UNITST_PRINTF(("__DMC__ = %#x\n", __DMC__));
  #elif defined __BORLANDC__
	UNITST_PRINTF(("__BORLANDC__ = %#x\n", __BORLANDC__));
  #elif defined __WATCOMC__
	UNITST_PRINTF(("__WATCOMC__ = %d\n", __WATCOMC__));
  #endif
}


int main()
{
	compiler_version();
	UNITST_RUN_ALL();
	return 0;
}
